/*
 * @(#)accept.c (pasori)
 *
 * Pasoriɥ饤 ǥХ׵ν
 * (C)Copyright 2009, Yashiro Takeshi
 */

#include "pasori.h"
#include "pasori_internal.h"


/*
 * ɥ쥹֤ȥå
 */
static ERR setAndCheckTaskSpace(DevReq *devReq)
{
  ERR	err;

  if (devReq->cmd.adcnv == 0 || devReq->datacnt <= 0) {
    return ER_OK;
  }

  /* ɥ쥹֤ */
  err = SetTaskSpace(devReq->taskid);
  if (err != ER_OK) {
    DEBUG_PRINT(("SetTaskSpace err = %d\n", err));
    return err;
  }

  /* ɥ쥹֤Υå */
  if (devReq->cmd.cmd == DC_READ) {
    err = CheckSpaceRW(devReq->memptr, devReq->datacnt);
  }
  else {
    err = CheckSpaceR(devReq->memptr, devReq->datacnt);
  }

  if (err != ER_OK) {
    DEBUG_PRINT(("CheckSpace err = %d\n", err));
    return err;
  }

  return ER_OK;
}


/*
 * ǡȤΥå
 *	return < 0 : 顼
 *	       > 0 : devReq->datacnt;
 */
static WERR CheckDataCnt(DevReq *devReq, W datasz)
{
  W reqcnt = devReq->datacnt;

  if (reqcnt < datasz) {
    if (reqcnt != 0) {
      return toERR(EC_PAR, ED_DATACNT);
    }
  }
  return reqcnt;
}


/*
 * W ѥ᡼
 */
static WERR getParamW(DevReq *devReq, UW *param)
{
  ERR	err;

  err = CheckDataCnt(devReq, sizeof(UW));
  if (err < 0) {
    goto err_ret;
  }
  if (err == 0) {
    return sizeof(UW);
  }

  *(UW*)devReq->memptr = *param;
  return sizeof(UW);

err_ret:
  DEBUG_PRINT(("getParamW err = %d\n", err));
  return err;
}


/*
 * W ѥ᡼
 */
static WERR setParamW(DevReq *devReq, UW *param)
{
  ERR err;

  err = CheckDataCnt(devReq, sizeof(UW));
  if (err < 0) {
    goto err_ret;
  }
  if (err == 0) {
    return sizeof(UW);
  }

  *param = *(UW*)devReq->memptr;
  return sizeof(UW);

err_ret:
  DEBUG_PRINT(("setParamW err = %d\n", err));
  return err;
}


/*
 * åХåեΥꥢ
 */
static WERR my_clr_mbf(ID mbfid)
{
  T_RMBF rmbf;
  ERR err;
  B buf[256];

  err = ref_mbf(&rmbf, mbfid);
  if (err < 0) {
    return err;
  }

  while (rmbf.msgsz > 0) {
    INT msgsz = min(rmbf.msgsz, sizeof(buf));
    err = rcv_mbf(buf, &msgsz, mbfid);
    if (err < 0) {
      return err;
    }
    rmbf.msgsz -= msgsz;
  }

  return E_OK;
}


/*
 * ǡ
 */
static WERR receiveData(PasoriInfo *info, DevReq *devReq)
{
  usbMsg usbmsg;
  INT msglen;
  ERR err;
  W len;

  /* 餫ᡢåХåեˤƤ */
  my_clr_mbf(info->mbfid);

  /*  */
  err = usbIoPipe(info->pipeid, devReq->memptr, devReq->datacnt, &len);
  if (err < ER_OK && err != USB_ERR_IO_SHORT) {
    goto err_ret;
  }

  /* ǡμλԤ*/
  for (;;) {
    msglen = sizeof(usbMsg);
    /* FIXME: в֤˱Ԥ֤򸺤餹 */
    err = trcv_mbf(&usbmsg, &msglen, info->mbfid, info->tmout);
    if (err < 0) {
      if (err == E_RLWAI || err == E_TMOUT) {
        err = toERR(EC_IO, err);
      }
      goto err_ret_cancel;
    }
    if (msglen < sizeof(usbMsg)) {
      err = ER_INNER;
      goto err_ret_cancel;
    }

    switch (usbmsg.error) {

    case USB_ERR_STALL:
      usbStallPipe(usbmsg.pid, 0); /* CLEAR_FEATURE */
      err = toERR(EC_IO, usbmsg.error);
      goto err_ret_cancel;

    case USB_OK:
      len = usbmsg.datacnt;
      goto rcv_ok;

    default:
      err = toERR(EC_IO, usbmsg.error);
      goto err_ret_cancel;
    }
  }

rcv_ok:
  return len;

err_ret_cancel:
  usbCancelPipe(info->pipeid);
err_ret:
  DEBUG_PRINT(("receiveData err = %d\n", err));
  return err;
}


/*
 * ǡ
 */
static WERR sendData(PasoriInfo *info, DevReq *devReq)
{
  usbDeviceRequest usbreq;
  ERR err;
  W len;

  /* USBǥХ׵ */
  usbreq.bmRequestType = bmR_VENDOR;
  usbreq.bRequest = 0;
  usbreq.wValue = 0;
  usbreq.wIndex = 0;
  usbreq.wLength = devReq->datacnt;

  /* ǥХ׵ */
  err = usbRequestDevice(info->deviceAddr, &usbreq, 
                         devReq->memptr, devReq->datacnt, &len);
  if (err < ER_OK) {
    goto err_ret;
  }

  return len;

err_ret:
  DEBUG_PRINT(("sendData err = %d\n", err));
  return err;
}


/*
 * ǡɤ߽Ф
 */
static ERR readData(PasoriInfo *info, DevRsp *devRsp, DevReq *devReq)
{
  ERR err;

  /* ѥ᡼å */
  if (devReq->datacnt < 0) {
    err = toERR(EC_PAR, ED_DATACNT);
    goto err_ret;
  }

  /* ɥ쥹֤ȥå */
  err = setAndCheckTaskSpace(devReq);
  if (err < ER_OK) {
    goto err_ret;
  }

  switch (devReq->datano) {

  case 0:
    /* ǡμ */
    err = receiveData(info, devReq);
    if (err < ER_OK) {
      goto err_ret;
    }
    devRsp->datacnt = err;
    return ER_OK;

  case DN_PASORI_TMOUT:
    /* ॢȻ֤μ */
    err = getParamW(devReq, (UW*)&(info->tmout));
    if (err < ER_OK) {
      goto err_ret;
    }
    devRsp->datacnt = err;
    return ER_OK;

  default:
    err = toERR(EC_PAR, ED_DATANO);
    goto err_ret;
  }

err_ret:
  DEBUG_PRINT(("readData err = %d\n", err));
  return err;
}


/*
 * ǡ񤭹
 */
static ERR writeData(PasoriInfo* info, DevRsp *devRsp, DevReq *devReq)
{
  ERR	err;

  /* ѥ᡼å */
  if (devReq->datacnt < 0) {
    err = toERR(EC_PAR, ED_DATACNT);
    goto err_ret;
  }

  /* ɥ쥹֤ȥå */
  err = setAndCheckTaskSpace(devReq);
  if (err < ER_OK) {
    goto err_ret;
  }

  switch (devReq->datano) {

  case 0:
    /* ǡ */
    err = sendData(info, devReq);
    if (err < ER_OK) {
      goto err_ret;
    }
    devRsp->datacnt = err;
    return ER_OK;

  case DN_PASORI_TMOUT:
    /* ॢȻ֤ */
    err = setParamW(devReq, (UW*)&(info->tmout));
    if (err < ER_OK) {
      goto err_ret;
    }
    devRsp->datacnt = err;
    return ER_OK;

  default:
    err = toERR(EC_PAR, ED_DATANO);
    goto err_ret;
  }

err_ret:
  DEBUG_PRINT(("writeData err = %d\n", err));
  return err;
}


/*
 * ץ׵ν
 */
static ERR openDevice(PasoriInfo* info, ID devid)
{
  /* USB³ƤʤСץ׵Ϥ */
  if (info->pipeid < 0) {
    return ER_NODEV;
  }

  /* Ǥ˥ץ֤ʤ顢ץ */
  if (info->opened) {
    return ER_OK;
  }

  info->opened = True;
  return ER_OK;
}


/*
 * ׵ν
 */
static ERR closeDevice(PasoriInfo *info)
{
  info->opened = False;

  return ER_OK;
}


/*
 * ܡ׵ν
 */
static ERR abortRequest(PasoriInfo *info, DevReq *devReq)
{
  ERR err;

  /* ꤵ줿׵¹ʤ饢ܡȤ */
  if (info->devReq != NULL) {
    if (info->devReq->taskid == devReq->taskid
        && info->pipeid >= 0) {
      /* ܡȼ¹ */
      err = usbCancelPipe(info->pipeid);
      if (err < ER_OK) {
        goto err_ret;
      }

      /* åХåեǤԤ */
      rel_wai(info->tid_norm);
    }
  }

  return ER_OK;

err_ret:
  DEBUG_PRINT(("abortRequest err = %d\n", err));
  return err;
}


/*
 * ڥ׵ν
 */
static ERR suspendRequest(PasoriInfo* info)
{
  /* ߽νХܡȤ */
  if (info->devReq != NULL && info->pipeid >= 0) {
    /* ܡȼ¹ */
    usbCancelPipe(info->pipeid);

    /* åХåեǤԤ */
    rel_wai(info->tid_norm);
  }

  /* ڥɾ֤Ǥ뤳Ȥ򼨤 */
  Lock(&(info->lock));

  info->suspended = True;

  return ER_OK;
}


/*
 * ꥸ塼׵ν
 */
static ERR resumeRequest(PasoriInfo* info)
{
  /* ڥɴʳ̵뤹 */
  if (!info->suspended) {
    return ER_OK;
  }

  info->suspended = False;

  /* ڥɾ֤Ȥ򼨤 */
  Unlock(&(info->lock));

  return ER_OK;
}


/*
 * ǥХΥץ
 */
static ERR pasoriOpenDevice(PasoriInfo* info)
{
  T_CMBF cmbf;
  ERR err;

  /* 󥿥եΥץ */
  err = usbOpenInterface(info->deviceAddr, info->interfaceAddr);
  if (err < ER_OK) {
    DEBUG_PRINT(("usbOpenInterface (%d) err\n", err));
    goto err_ret0;
  }
  info->ifid = err;

  /* ɤߴλΤΤΥåХåե */
  cmbf.exinf  = info;
  cmbf.mbfatr = TA_NULL;
  cmbf.maxmsz = sizeof(usbMsg);
  cmbf.bufsz  = cmbf.maxmsz * 32;
  err = vcre_mbf(&cmbf);
  if (err < ER_OK) {
    goto err_ret1;
  }
  info->mbfid = err;

  /* ɥݥȤΥץ */
  err = usbOpenPipe(info->ifid, 0x81, USB_SHORTOK|USB_NOWAIT, info->mbfid);
  if (err < ER_OK) {
    DEBUG_PRINT(("usbOpenPipe (%d) err\n", err));
    goto err_ret2;
  }
  info->pipeid = err;

  /* ǰΤᡢCLEAR_FEATURE ȯԤơtoggle bit 򤽤Ƥ */
  usbStallPipe(info->pipeid, 0);

  return ER_OK;

err_ret2:
  usbCloseInterface(info->interfaceAddr);
  info->interfaceAddr = -1;
err_ret1:
  del_mbf(info->mbfid);
  info->mbfid = -1;
err_ret0:
  return err;
}


/*
 * USB٥(³/)ν
 */
static ERR pasoriUsbEvent(PasoriInfo* info, DevRsp* devRsp, DevReq* devReq)
{
  ERR err;
  W size;

  /* 󥿥եؤ׵ʳϤ
     (ǥХؤ׵ϼդʤ) */
  if ((devReq->devid & 0x80) == 0) {
    err = toERR(EC_PAR, ED_CMD);
    DEBUG_PRINT(("USB event devid (%d) err\n", devReq->devid));
    goto err_ret;
  }

  /* ǥХɥ쥹󥿥եֹμ */
  info->deviceAddr = devReq->devid & 0x7f;
  info->interfaceAddr = (devReq->devid & 0xff00) >> 8;

  switch (devReq->datano) {

  case USB_MOUNT:
    /* USBǥХǥץ
       (פʤΤǥե졼ʬޤޤʤ) */
    err = usbDescriptorDevice(info->deviceAddr, (UB*)&(info->deviceDesc),
                              sizeof(usbDeviceDescriptor), &size);
    if (err < ER_OK || size < sizeof(usbDeviceDescriptor)) {
      DEBUG_PRINT(("usbDescriptorDevice (%d) err\n", err));
      goto err_ret;
    }

    /* ٥IDȥץIDå */
    if (info->deviceDesc.idVendor != PASORI_VENDOR_ID) {
      err = USB_NONE;
      DEBUG_PRINT(("idVendor does not match (%d)\n", 
                   info->deviceDesc.idVendor));
      goto err_ret;
    }

    if (info->deviceDesc.idProduct != PASORI_S320_PRODUCT_ID) {
      err = USB_NONE;
      DEBUG_PRINT(("idProduct does not match (%d)\n", 
                   info->deviceDesc.idProduct));
      goto err_ret;
    }

    /* ǥХΥץ */
    err = pasoriOpenDevice(info);
    if (err < ER_OK) {
      DEBUG_PRINT(("device open (%d) err\n", err));
      goto err_ret;
    }

    err = USB_OWN;
    break;

  case USB_UNMOUNT:
    usbClosePipe(info->pipeid);
    info->pipeid = -1;

    usbCloseInterface(info->ifid);
    info->ifid = -1;

    info->deviceAddr = -1;
    info->interfaceAddr = -1;

    err = ER_OK;
    break;

  default:
    err = toERR(EC_PAR, ED_CMD);
    DEBUG_PRINT(("USB event datano (%d) err\n", devReq->datano));
    break;
  }

err_ret:
  return err;
}


/*
 * ǥХ׵μ¹
 *	devReq ׵̤ devRsp ֤
 */
static ERR execDeviceRequest(PasoriInfo *info, DevRsp *devRsp, DevReq *devReq)
{
  ERR err;

  switch (devReq->cmd.cmd) {
  case DC_OPEN:
    err = openDevice(info, devReq->devid);
    break;

  case DC_CLOSE:
  case DC_CLOSEALL:
    err = closeDevice(info);
    break;

  case DC_READ:
    err = readData(info, devRsp, devReq);
    break;

  case DC_WRITE:
    err = writeData(info, devRsp, devReq);
    break;

  case DC_ABORT:
    err = abortRequest(info, devReq);
    break;

  case DC_SUSPEND:
    err = suspendRequest(info);
    break;

  case DC_RESUME:
    err = resumeRequest(info);
    break;

  case DC_USBEVENT:
    err = pasoriUsbEvent(info, devRsp, devReq);
    break;

  default:
    /* ޥɥ顼 */
    err = toERR(EC_PAR, ED_CMD);
    DEBUG_PRINT(("devReq command(%d) err\n", devReq->cmd.cmd));
  }

  return err;
}


/*
 * ǥХ׵
 *	̾׵ü׵ξѤ
 */
extern ERR pasoriAcceptDeviceRequest(PasoriInfo *info, UW reqptn)
{
  DevReq devReq;
  DevRsp devRsp;
  UW acpptn;
  RNO rdvno;
  INT size;
  ERR err;

  for (;;) {
    acpptn = reqptn;
    if (info->suspended) {
      /* ڥϡDC_RESUME ʳü׵
         դߤ */
      acpptn &= (D_NORM_PTN|D_CALPTN(DC_RESUME));
    }

    /* ׵դ */
    err = acp_por(&rdvno, &devReq, &size,
                  info->acceptPort, acpptn);
    if (err < E_OK) {
      DEBUG_PRINT(("acp_por er = %d\n", err));
      continue;
    }

    /* ѥåȤν */
    devRsp.devid   = devReq.devid;
    devRsp.cmd	   = devReq.cmd;
    devRsp.datano  = devReq.datano;
    devRsp.datacnt = 0;

    if (size != sizeof(DevReq)) {
      err = toERR(EC_PAR, ED_CMD);
      DEBUG_PRINT(("invalid devReq size (%d)\n", size));
      goto err_skip;
    }

    
    if ((D_CALPTN(devReq.cmd.cmd) & D_NORM_PTN) != 0) {
      /* ܡоݤȤʤ¹Ǥ뤳ȤϿ */
      info->devReq = &devReq;

      /*
       * acp_por äƤ餳ޤǤδ֤ˡü׵
       * ¹ԤƤϤʤΤᡢԤ
       * 褦ʥƥॳȯԤƤϤʤ
       */

      /* ü׵᤬׵ᤵƤˤϡͥ褹
         褦˰ö¹Ը롣*/
      rot_rdq(TPRI_RUN);

      /* ̾׵νǤ뤳Ȥ򼨤 */
      Lock(&(info->lock));
    }

    /* ¹ */
    err = execDeviceRequest(info, &devRsp, &devReq);

    if ((D_CALPTN(devReq.cmd.cmd) & D_NORM_PTN) != 0) {
      /* ̾׵νλ򼨤 */
      Unlock(&(info->lock));

      /* ܡоݤȤʤλȤϿ */
      info->devReq = NULL;
    }

  err_skip:
    devRsp.error.err = err;

    /*  */
    err = rpl_rdv(rdvno, (VP)&devRsp, sizeof(DevRsp));
    if (err < E_OK) {
      DEBUG_PRINT(("rpl_rdv er = %d\n", err));
    }
  }

  return ER_SYS; /* 뤳ȤϤʤϤ */
}
