/*
 * @(#)main.C (pasori)
 *
 * Pasoriɥ饤 
 * (C)Copyright 2009, Yashiro Takeshi
 */

#include "pasori.h"
#include "pasori_internal.h"
#include <bstring.h>
#include <tstring.h>
#include <tctype.h>

#include <driver/pcat/biosp.h>
#include <driver/hwres.h>
#include <driver/usb.h>

/*
 * Pasoriɥ饤Хͥ
 */
static PRI taskPri = 85; /* ǥեͥ */


/*
 * ǥХϿ/
 *	Ͽ	reg = True
 *		reg = False
 */
static WERR registDevice(PasoriInfo* info, Bool reg)
{
  static TC devname[] = {L""};
  DevDef devdef;
  ERR err;

  /* Ͽ */
  bzero(&devdef, sizeof(DevDef));
  devdef.attr.devinfo = 0;
  devdef.attr.devkind = DK_UNDEF;
  devdef.attr.openreq = 0; /* 󥪡ץ/ɬ */
  devdef.attr.lockreq = 0; /* ɥ쥹֤Υåɬ */
  devdef.attr.diskinfo = 0;
  devdef.attr.chardev = 1;
  devdef.attr.nowait = 0;
  devdef.attr.eject = 0;
  devdef.subunits = 0;
  tc_strncpy(devdef.name, devname, L_DEVNM);
  devdef.portid = (reg ? info->acceptPort : 0);

  /* ǥХϿ/ */
  // FIXME: reg = False ΤȤκޤʤ
  err = b_DefDevice(&devdef, NULL);
  if (err < ER_OK) {
    goto err_ret0;
  }
  info->devid = err;

  /* USB٥ȤϿ/(äȸ̩) */
  if (reg) {
    usbEventPattern ptn;
    ptn.bClass = 255; /* 255: vendor specific */
    ptn.bSubClass = 0;
    ptn.bProtocol = 0;
    ptn.mask = EVENT_CLASS|EVENT_SUBCLASS|EVENT_PROTOCOL;
    err = usbRegistInterface(info->acceptPort, &ptn);
    if (err < ER_OK) {
      err = toERR(EC_INNER, err);
      goto err_ret1;
    }
  }
  else {
    usbRegistInterface(info->acceptPort, NULL);
  }

  return ER_OK;

err_ret1:
  if (reg) {
    devdef.portid = 0;
    b_DefDevice(&devdef, NULL);
  }
err_ret0:
  DEBUG_PRINT(("registDevice err = %d\n", err));
  return err;
}


/*
 * ü׵դ
 */
static void pasoriSpecificRequestTask(PasoriInfo *info)
{
  ERR err;

  /* ǥХ׵դ */
  err = pasoriAcceptDeviceRequest(info, D_ABORT_PTN);

  /*
   * ǥХɥ饤С̾ｪλʤΤǡ
   * 뤳ȤϤʤϤ
   */

  DEBUG_PRINT(("rsSpecificRequestTask err = %d\n", err));
  exd_tsk();
}


/*
 * Pasoriɥ饤Сᥤ󥿥
 * (̾׵դ)
 */
static void pasoriMainTask(PasoriInfo* info)
{
  T_CPOR cpor;
  T_CTSK ctsk;
  ERR err;

  /* å */
  err = CreateLockWN(&(info->lock), "pasori");
  if (err < ER_OK) {
    goto err_ret0;
  }

  /* ǥХ׵դѥǥ֥ݡȤ */
  cpor.exinf   = NULL;
  cpor.poratr  = TA_NULL;
  cpor.maxcmsz = sizeof(DevReq);
  cpor.maxrmsz = sizeof(DevRsp);
  err = vcre_por(&cpor);
  if (err < ER_OK) {
    err = toERR(EC_INNER, err);
    goto err_ret1;
  }
  info->acceptPort = err;

  /* ü׵ե */
  ctsk.exinf   = info;
  ctsk.task    = pasoriSpecificRequestTask;
  ctsk.itskpri = info->mypri;
  ctsk.stksz   = 2048;
  ctsk.tskatr  = TA_HLNG|TA_RNG0;

  err = vcre_tsk(&ctsk);
  if (err < ER_OK) {
    err = toERR(EC_INNER, err);
    goto err_ret2;
  }
  info->tid_spec = err;

  err = sta_tsk(info->tid_spec, (INT)info);
  if (err < ER_OK) {
    err = toERR(EC_INNER, err);
    goto err_ret3;
  }

  /* ǥХϿ */
  err = registDevice(info, True);
  if (err < ER_OK) {
    goto err_ret4;
  }

  /* ǥХ׵դ */
  err = pasoriAcceptDeviceRequest(info, D_NORM_PTN);
  if (err < ER_OK) {
    goto err_ret5;
  }

  /*
   * ǥХɥ饤С̾ｪλʤΤǡ
   * 뤳ȤϤʤϤ
   */

  /* λ */
err_ret5:
  registDevice(info, False);
err_ret4:
  ter_tsk(info->tid_spec);
err_ret3:
  del_tsk(info->tid_spec);
err_ret2:
  del_por(info->acceptPort);
err_ret1:
  DeleteLock(&(info->lock));
err_ret0:
  Kfree(info);
  DEBUG_PRINT(("pasoriMainTask err = %d\n", err));
  exd_tsk();
}

/* ------------------------------------------------------------------------ */

static volatile PasoriInfo* info_ = NULL;


/*
 * Pasoriɥ饤СΤư
 */
static WERR startPasoriDriver(PRI pri)
{
  PasoriInfo* info = NULL;
  T_CTSK ctsk;
  ERR err;

  /* ɥ饤оν */
  info = (PasoriInfo*)Kcalloc(1, sizeof(PasoriInfo));
  if (info == NULL) {
    err = ER_NOMEM;
    goto err_ret0;
  }
  info_ = info;

  info->mypri = pri;
  info->devid = -1;
  info->acceptPort = -1;

  info->tid_norm = -1;
  info->tid_spec = -1;

  info->deviceAddr = -1;
  info->interfaceAddr = -1;

  info->ifid = -1;
  info->pipeid = -1;

  info->mbfid = -1;

  info->tmout = PASORI_RW_DEFAULT_TMOUT;

  info->opened = 0;
  info->suspended = 0;

  /* εư */
  ctsk.exinf   = info;
  ctsk.task    = pasoriMainTask;
  ctsk.itskpri = pri;
  ctsk.stksz   = 2048;
  ctsk.tskatr  = TA_HLNG|TA_RNG0;

  err = vcre_tsk(&ctsk);
  if (err < E_OK) {
    err = toERR(EC_INNER, err);
    goto err_ret1;
  }
  info->tid_norm = err;

  err = sta_tsk(info->tid_norm, (INT)info);
  if (err < E_OK) {
    err = toERR(EC_INNER, err);
    goto err_ret2;
  }

  return info->tid_norm;

err_ret2:
  del_tsk(info->tid_norm);
  info->tid_norm = -1;
err_ret1:
  Kfree(info);
err_ret0:
  DEBUG_PRINT(("startPasoriDriver err = %d\n", err));
  return err;
}


/*
 * Pasoriɥ饤СΤνλ(ʤꤤ)
 */
static WERR stopPasoriDriver()
{
  PasoriInfo* info = info_;

  if (info == NULL) {
    return ER_OK;
  }

  /* Ȥꤢ̾׵ϥ֥å */
  Lock(&(info->lock));

  if (info->tid_spec >= 0) {
    ter_tsk(info->tid_spec);
    del_tsk(info->tid_spec);
    info->tid_spec = -1;
  }

  if (info->tid_norm >= 0) {
    ter_tsk(info->tid_norm);
    del_tsk(info->tid_norm);
    info->tid_norm = -1;
  }

  if (info->acceptPort >= 0) {
    del_por(info->acceptPort);
    info->acceptPort = -1;
  }

  if (info->mbfid >= 0) {
    del_mbf(info->mbfid);
    info->mbfid = -1;
  }

  if (info->pipeid >= 0) {
    usbCancelPipe(info->pipeid);
    usbClosePipe(info->pipeid);
    info->pipeid = -1;
  }

  if (info->ifid >= 0) {
    usbCloseInterface(info->ifid);
    info->ifid = -1;
  }

  registDevice(info, False);
  info->devid = -1;

  Unlock(&(info->lock));
  DeleteLock(&(info->lock));

  Kfree(info);
  info_ = NULL;

  return ER_OK;
}


/*
 * ѥ᡼Ф
 */
static ERR getParameter(TC *arg)
{
  while (*arg != TNULL) {
    if (tc_isspace(*arg)) {
      arg++;
      continue;
    }

    switch (*arg++) {
    case L'': /* ͥ */
      taskPri = tc_strtol(arg, &arg, 0);
      break;
    default:
      return ER_PAR;
    }
  }

  return ER_OK;
}


/*
 * Pasoriɥ饤
 */
ERR main(Bool StartUp, TC *arg)
{
  ERR err;

  if (!StartUp) {
    /* ɥ饤Фνλ */
    stopPasoriDriver();

    return ER_OK;
  }

  if (arg != NULL) {
    /* ѥ᡼Ф */
    err = getParameter(arg);
    if (err < ER_OK) {
      return err;
    }
  }

  /* ɥ饤Фγ */
  startPasoriDriver(taskPri);

  return ER_OK;
}
